
package de.ivu.elect.presentation.veranstaltung;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.veranstaltung.boundary.TeilnahmeConversationStore;
import de.ivu.elect.business.veranstaltung.boundary.TeilnahmeExtendedDAO;
import de.ivu.elect.business.veranstaltung.boundary.TeilnahmeEdit;
import de.ivu.elect.business.veranstaltung.entity.Teilnahme;
import de.ivu.elect.business.veranstaltung.entity.TeilnahmeMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractTeilnahmeEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractTeilnahmeEditNoScopeView.VIEW_ID, useCase = UseCasePermission.TEILNAHME_EDIT)
public abstract class AbstractTeilnahmeEditNoScopeView extends de.ivu.elect.presentation.AbstractElectEditView<Teilnahme>  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "teilnahmeEditView";

  public static final String VIEW_ID = "/veranstaltung/teilnahme-edit.xhtml";

  public static final String PARENT_VIEW_ID = "/veranstaltung/teilnahme-search.xhtml";

  @Inject
  protected transient TeilnahmeExtendedDAO extendedDAO;

  @Inject
  protected transient TeilnahmeEdit edit;

  @Inject
  @ConversationGroup(TeilnahmeConversationStore.class)
  protected transient TeilnahmeConversationStore conversationStore;

  @Inject
  protected transient TeilnahmeMeta entityMeta;

  @Inject
  // ELECTDD-204 Auf doppelte Bearbeitung von Entitäten Hinweisen
  protected transient TeilnahmeEditViewScopeStore entityViewStore;

  @de.ivu.elect.jee.faces.PreConditionCheck
  public String checkPreCondition() {
    if (getEntity() == null) {
      return getParentViewId();
    }
    return null;
  }

  @Override
  public Teilnahme getEntity() {
    if (conversationStore.getEntityPK() != null) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }
    return null;
  }

  public void setEntity(Teilnahme entity) {
    resetModel(); // DynaForm-Model zurücksetzen, damit die aktuelle Entität verwendte wird...
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  public boolean isEntitySet() {
    return conversationStore.getEntityPK() != null;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.TEILNAHME_DELETE)
  @Override
  public String delete() {
    return delete(getEntity());
  }

  protected String delete(Teilnahme entity) {
    edit.delete(entity);

    addMessageDeleteSuccess();

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }



  @Redirect
  @UseCaseSecure(UseCasePermission.TEILNAHME_DELETE)
  public String deleteAndGoBack() {
    delete();
    return goBack(getParentViewId());
  }

  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnDeleteRendered() {
    return hasPermission(UseCasePermission.TEILNAHME_DELETE);
  }

  @Redirect
  @Override
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.TEILNAHME_EDIT)
  @Override
  public String save() {
    Teilnahme entity = getEntity();

    callSave(entity);

    addMessageSaveSuccess(entity);

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Teilnahme entity) {
    edit.save(entity);
  }

  @Redirect
  @Override
  public String reset() {
    super.reset();
    Teilnahme entity = getEntity();
    resetStateAfterAction();
    setEntity(entity);
    return getViewId();
  }

  protected void addMessageSaveSuccess(Teilnahme entity) {
    addInfoMessage("entity.edit.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.TEILNAHME_EDIT);
  }
  
  @Redirect
  public String edit(Teilnahme entity) {
    conversationStore.setEntityPK(entity.getPk());
    return getViewId();
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    conversationStore.close();
  }

  @de.ivu.elect.jee.faces.PreConditionCheck
  public void checkDoppelteBearbeitung() {
     entityViewStore.setEntity(getEntity());
  }

  @org.apache.deltaspike.core.api.scope.ViewAccessScoped
  public static class TeilnahmeEditViewScopeStore extends  de.ivu.elect.presentation.edit.AbstractViewScopeStore<Teilnahme,   de.ivu.elect.business.veranstaltung.entity.TeilnahmePK  > {

    private static final long serialVersionUID = 1L;
  }
}
